/*
 *  w32api.h    MinGW compatibility header
 *
 *                          Open Watcom Project
 *
 * Copyright (c) 2004-2008 The Open Watcom Contributors. All Rights Reserved.
 *
 *    This file is automatically generated. Do not edit directly.
 *
 * =========================================================================
 */

/* This header exists solely for compatibility with MinGW.  There is no version of it
 * included in the Microsoft SDK.  New code should not include this header or make
 * reference to the constants in it.
 */

#if !defined(_ENABLE_AUTODEPEND)
  #pragma read_only_file;
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* These constants specify the version of the w32api package from MinGW with which these
 * headers are compatible.  Do not update these constants to indicate a new version of
 * Open Watcom.
 */
#define __W32API_VERSION        3.9
#define __W32API_MAJOR_VERSION  3
#define __W32API_MINOR_VERSION  9

/* These constants are used to test for different Windows version.  New code should use
 * the constants in sdkddkver.h instead.
 */
#define Windows95       0x0400
#define Windows98       0x0410
#define WindowsME       0x0500
#define WindowsNT4      0x0400
#define Windows2000     0x0500
#define WindowsXP       0x0501
#define Windows2003     0x0502
#define WindowsVista    0x0600
#define IE3             0x0300
#define IE301           0x0300
#define IE302           0x0300
#define IE4             0x0400
#define IE401           0x0401
#define IE5             0x0500
#define IE5a            0x0500
#define IE5b            0x0500
#define IE501           0x0501
#define IE55            0x0501
#define IE56            0x0560
#define IE6             0x0600
#define IE601           0x0601
#define IE602           0x0603
#define IE7             0x0700

#ifdef __cplusplus
} /* End of extern "C" */
#endif

